#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <memory.h>
#include <sock.h>

int
signal_wackyd( char *hostname, char *pattern, char *message, int priority )
{
  CONN *C;
  int  fail;
  int  retry=0, okay=0;
  char payload[1024];
  char tmp[256];

  if( strlen( message ) > 1 ){
    snprintf( tmp, sizeof( tmp ), "MESSAGE: %s\015\012", message );
  }
  else{
    tmp[0]=0;
  }

  snprintf( 
    payload, sizeof(payload), 
    "WACKY/1.0 %s \015\012"
    "PRIORITY: %d \015\012"
    "%s"
    "\015\012",
    pattern, priority, tmp
  );

  C = xmalloc( sizeof( CONN ));
  C->prot = WACKY;

  do{
    if(( C->sock = WLsocket( C, hostname, 9193 )) < 0 ){
      retry ++;
      okay = 0;
      fail = 1;
      C->sock = 0;
    }
    else{ okay = 1; }
  } while( !okay && retry < 3 );
  if( !okay ){ return -1; }   

  WLsocket_write( C, payload, sizeof( payload ));
  WLsocket_write( C, "\n", 1 );
  WLclose( C );
  return 0;
}
